// Code generated by kun; DO NOT EDIT.
// github.com/RussellLuo/kun

package profilesvc

import (
	"context"
	"fmt"
	"net/http"
	"net/url"
	"strings"

	"github.com/RussellLuo/kun/pkg/httpcodec"
)

type HTTPClient struct {
	codecs     httpcodec.Codecs
	httpClient *http.Client
	scheme     string
	host       string
	pathPrefix string
}

func NewHTTPClient(codecs httpcodec.Codecs, httpClient *http.Client, baseURL string) (*HTTPClient, error) {
	u, err := url.Parse(baseURL)
	if err != nil {
		return nil, err
	}
	return &HTTPClient{
		codecs:     codecs,
		httpClient: httpClient,
		scheme:     u.Scheme,
		host:       u.Host,
		pathPrefix: strings.TrimSuffix(u.Path, "/"),
	}, nil
}

func (c *HTTPClient) DeleteAddress(ctx context.Context, id string, addressID string) (err error) {
	codec := c.codecs.EncodeDecoder("DeleteAddress")

	path := fmt.Sprintf("/profiles/%s/addresses/%s",
		codec.EncodeRequestParam("id", id)[0],
		codec.EncodeRequestParam("addressID", addressID)[0],
	)
	u := &url.URL{
		Scheme: c.scheme,
		Host:   c.host,
		Path:   c.pathPrefix + path,
	}

	_req, err := http.NewRequest("DELETE", u.String(), nil)
	if err != nil {
		return err
	}

	_resp, err := c.httpClient.Do(_req)
	if err != nil {
		return err
	}
	defer _resp.Body.Close()

	if _resp.StatusCode < http.StatusOK || _resp.StatusCode > http.StatusNoContent {
		var respErr error
		err := codec.DecodeFailureResponse(_resp.Body, &respErr)
		if err == nil {
			err = respErr
		}
		return err
	}

	return nil
}

func (c *HTTPClient) DeleteProfile(ctx context.Context, id string) (err error) {
	codec := c.codecs.EncodeDecoder("DeleteProfile")

	path := fmt.Sprintf("/profiles/%s",
		codec.EncodeRequestParam("id", id)[0],
	)
	u := &url.URL{
		Scheme: c.scheme,
		Host:   c.host,
		Path:   c.pathPrefix + path,
	}

	_req, err := http.NewRequest("DELETE", u.String(), nil)
	if err != nil {
		return err
	}

	_resp, err := c.httpClient.Do(_req)
	if err != nil {
		return err
	}
	defer _resp.Body.Close()

	if _resp.StatusCode < http.StatusOK || _resp.StatusCode > http.StatusNoContent {
		var respErr error
		err := codec.DecodeFailureResponse(_resp.Body, &respErr)
		if err == nil {
			err = respErr
		}
		return err
	}

	return nil
}

func (c *HTTPClient) GetAddress(ctx context.Context, id string, addressID string) (address Address, err error) {
	codec := c.codecs.EncodeDecoder("GetAddress")

	path := fmt.Sprintf("/profiles/%s/addresses/%s",
		codec.EncodeRequestParam("id", id)[0],
		codec.EncodeRequestParam("addressID", addressID)[0],
	)
	u := &url.URL{
		Scheme: c.scheme,
		Host:   c.host,
		Path:   c.pathPrefix + path,
	}

	_req, err := http.NewRequest("GET", u.String(), nil)
	if err != nil {
		return Address{}, err
	}

	_resp, err := c.httpClient.Do(_req)
	if err != nil {
		return Address{}, err
	}
	defer _resp.Body.Close()

	if _resp.StatusCode < http.StatusOK || _resp.StatusCode > http.StatusNoContent {
		var respErr error
		err := codec.DecodeFailureResponse(_resp.Body, &respErr)
		if err == nil {
			err = respErr
		}
		return Address{}, err
	}

	respBody := &GetAddressResponse{}
	err = codec.DecodeSuccessResponse(_resp.Body, respBody.Body())
	if err != nil {
		return Address{}, err
	}
	return respBody.Address, nil
}

func (c *HTTPClient) GetAddresses(ctx context.Context, id string) (addresses []Address, err error) {
	codec := c.codecs.EncodeDecoder("GetAddresses")

	path := fmt.Sprintf("/profiles/%s/addresses",
		codec.EncodeRequestParam("id", id)[0],
	)
	u := &url.URL{
		Scheme: c.scheme,
		Host:   c.host,
		Path:   c.pathPrefix + path,
	}

	_req, err := http.NewRequest("GET", u.String(), nil)
	if err != nil {
		return nil, err
	}

	_resp, err := c.httpClient.Do(_req)
	if err != nil {
		return nil, err
	}
	defer _resp.Body.Close()

	if _resp.StatusCode < http.StatusOK || _resp.StatusCode > http.StatusNoContent {
		var respErr error
		err := codec.DecodeFailureResponse(_resp.Body, &respErr)
		if err == nil {
			err = respErr
		}
		return nil, err
	}

	respBody := &GetAddressesResponse{}
	err = codec.DecodeSuccessResponse(_resp.Body, respBody.Body())
	if err != nil {
		return nil, err
	}
	return respBody.Addresses, nil
}

func (c *HTTPClient) GetProfile(ctx context.Context, id string) (profile Profile, err error) {
	codec := c.codecs.EncodeDecoder("GetProfile")

	path := fmt.Sprintf("/profiles/%s",
		codec.EncodeRequestParam("id", id)[0],
	)
	u := &url.URL{
		Scheme: c.scheme,
		Host:   c.host,
		Path:   c.pathPrefix + path,
	}

	_req, err := http.NewRequest("GET", u.String(), nil)
	if err != nil {
		return Profile{}, err
	}

	_resp, err := c.httpClient.Do(_req)
	if err != nil {
		return Profile{}, err
	}
	defer _resp.Body.Close()

	if _resp.StatusCode < http.StatusOK || _resp.StatusCode > http.StatusNoContent {
		var respErr error
		err := codec.DecodeFailureResponse(_resp.Body, &respErr)
		if err == nil {
			err = respErr
		}
		return Profile{}, err
	}

	respBody := &GetProfileResponse{}
	err = codec.DecodeSuccessResponse(_resp.Body, respBody.Body())
	if err != nil {
		return Profile{}, err
	}
	return respBody.Profile, nil
}

func (c *HTTPClient) PatchProfile(ctx context.Context, id string, profile Profile) (err error) {
	codec := c.codecs.EncodeDecoder("PatchProfile")

	path := fmt.Sprintf("/profiles/%s",
		codec.EncodeRequestParam("id", id)[0],
	)
	u := &url.URL{
		Scheme: c.scheme,
		Host:   c.host,
		Path:   c.pathPrefix + path,
	}

	reqBody := struct {
		Profile Profile `json:"profile"`
	}{
		Profile: profile,
	}
	reqBodyReader, headers, err := codec.EncodeRequestBody(&reqBody)
	if err != nil {
		return err
	}

	_req, err := http.NewRequest("PATCH", u.String(), reqBodyReader)
	if err != nil {
		return err
	}

	for k, v := range headers {
		_req.Header.Set(k, v)
	}

	_resp, err := c.httpClient.Do(_req)
	if err != nil {
		return err
	}
	defer _resp.Body.Close()

	if _resp.StatusCode < http.StatusOK || _resp.StatusCode > http.StatusNoContent {
		var respErr error
		err := codec.DecodeFailureResponse(_resp.Body, &respErr)
		if err == nil {
			err = respErr
		}
		return err
	}

	return nil
}

func (c *HTTPClient) PostAddress(ctx context.Context, id string, address Address) (err error) {
	codec := c.codecs.EncodeDecoder("PostAddress")

	path := fmt.Sprintf("/profiles/%s/addresses",
		codec.EncodeRequestParam("id", id)[0],
	)
	u := &url.URL{
		Scheme: c.scheme,
		Host:   c.host,
		Path:   c.pathPrefix + path,
	}

	reqBody := struct {
		Address Address `json:"address"`
	}{
		Address: address,
	}
	reqBodyReader, headers, err := codec.EncodeRequestBody(&reqBody)
	if err != nil {
		return err
	}

	_req, err := http.NewRequest("POST", u.String(), reqBodyReader)
	if err != nil {
		return err
	}

	for k, v := range headers {
		_req.Header.Set(k, v)
	}

	_resp, err := c.httpClient.Do(_req)
	if err != nil {
		return err
	}
	defer _resp.Body.Close()

	if _resp.StatusCode < http.StatusOK || _resp.StatusCode > http.StatusNoContent {
		var respErr error
		err := codec.DecodeFailureResponse(_resp.Body, &respErr)
		if err == nil {
			err = respErr
		}
		return err
	}

	return nil
}

func (c *HTTPClient) PostProfile(ctx context.Context, profile Profile) (err error) {
	codec := c.codecs.EncodeDecoder("PostProfile")

	path := "/profiles"
	u := &url.URL{
		Scheme: c.scheme,
		Host:   c.host,
		Path:   c.pathPrefix + path,
	}

	reqBody := struct {
		Profile Profile `json:"profile"`
	}{
		Profile: profile,
	}
	reqBodyReader, headers, err := codec.EncodeRequestBody(&reqBody)
	if err != nil {
		return err
	}

	_req, err := http.NewRequest("POST", u.String(), reqBodyReader)
	if err != nil {
		return err
	}

	for k, v := range headers {
		_req.Header.Set(k, v)
	}

	_resp, err := c.httpClient.Do(_req)
	if err != nil {
		return err
	}
	defer _resp.Body.Close()

	if _resp.StatusCode < http.StatusOK || _resp.StatusCode > http.StatusNoContent {
		var respErr error
		err := codec.DecodeFailureResponse(_resp.Body, &respErr)
		if err == nil {
			err = respErr
		}
		return err
	}

	return nil
}

func (c *HTTPClient) PutProfile(ctx context.Context, id string, profile Profile) (err error) {
	codec := c.codecs.EncodeDecoder("PutProfile")

	path := fmt.Sprintf("/profiles/%s",
		codec.EncodeRequestParam("id", id)[0],
	)
	u := &url.URL{
		Scheme: c.scheme,
		Host:   c.host,
		Path:   c.pathPrefix + path,
	}

	reqBody := struct {
		Profile Profile `json:"profile"`
	}{
		Profile: profile,
	}
	reqBodyReader, headers, err := codec.EncodeRequestBody(&reqBody)
	if err != nil {
		return err
	}

	_req, err := http.NewRequest("PUT", u.String(), reqBodyReader)
	if err != nil {
		return err
	}

	for k, v := range headers {
		_req.Header.Set(k, v)
	}

	_resp, err := c.httpClient.Do(_req)
	if err != nil {
		return err
	}
	defer _resp.Body.Close()

	if _resp.StatusCode < http.StatusOK || _resp.StatusCode > http.StatusNoContent {
		var respErr error
		err := codec.DecodeFailureResponse(_resp.Body, &respErr)
		if err == nil {
			err = respErr
		}
		return err
	}

	return nil
}
